import java.io.*;
import java.net.*;
import java.util.*;

class Conversion {
  public static float enNombre(String texte) {
    float f;
    try {
      f = Float.parseFloat(texte);
    } catch (Exception e) {
      f = Float.NaN;
    }
    return f;
  }
  public static char enCaractere(String texte) {
    if (texte.equals("")) return ' ';
    return texte.charAt(0);
  }
}

class DialogueAvecUnClient extends Thread {
  protected Socket communicationAvecLeClient;
  protected BufferedReader ecouteurDuCombine;
  protected PrintStream microphoneDuCombine;
  public DialogueAvecUnClient(Socket uneCommunicationAvecUnClient) throws Exception {
    communicationAvecLeClient = uneCommunicationAvecUnClient;
    ecouteurDuCombine = new BufferedReader(new InputStreamReader(communicationAvecLeClient.getInputStream()));
    microphoneDuCombine = new PrintStream(communicationAvecLeClient.getOutputStream());
  }
  private float calcul(float n1, char op, float n2) {
    switch (op) {
      case '+' : return n1 + n2;
      case '-' : return n1 - n2;
      case '*' :
      case 'x' : return n1 * n2;
      case '/' : return n1 / n2;
      default  : return Float.NaN;
    }
  }
  public void run() {
    String lu;
    int nbElem;
    float n1 = 0, n2 = 0, r = 0;
    char op = ' ';
    StringTokenizer st;
    boolean fini = false;
    try {
	do {
        lu = ecouteurDuCombine.readLine(); //"entendre" le client par l'"couteur du combin"
        fini = lu.equals(".");
        if (!fini) {
          st = new StringTokenizer(lu, " ");
          nbElem = 0;
          while (st.hasMoreTokens()) {
            nbElem++;
            switch(nbElem) {
              case 1: n1 = Conversion.enNombre(st.nextToken()); break;
              case 2: op = Conversion.enCaractere(st.nextToken()); break;
              case 3: n2 = Conversion.enNombre(st.nextToken()); break;
            }
          }
          if (nbElem == 3) {
            r = calcul(n1, op, n2);
            microphoneDuCombine.println("= " + r);
          } else {
            microphoneDuCombine.println("= " + Float.NaN);
          }
        }
      } while (!fini);
    } catch (IOException e1) {}
    try {
      communicationAvecLeClient.close();
    } catch (IOException e2) {}
  }
}

class TraitementDesAppels extends Thread {
  protected ServerSocket standardTelephonique;
  protected boolean onPoursuit;
  public TraitementDesAppels(ServerSocket unStandardTelephonique) {
    standardTelephonique = unStandardTelephonique;
    onPoursuit = true;
  }
  public void run() {
    Socket uneCommunicationAvecUnClient;
    while (onPoursuit) {
      try {
//recevoir un appel
        uneCommunicationAvecUnClient = standardTelephonique.accept();
//tablir le dialogue avec le client qui a appel
        DialogueAvecUnClient unDialogueClient = new DialogueAvecUnClient(uneCommunicationAvecUnClient);
        unDialogueClient.start();
      } catch(Exception e) {}
    }
  }
  public void termine() {
    onPoursuit = false;
  }
}

class ServeurCalcul {
  public final static int PortParDefaut = 3000;
  private static int port;
  public static void main(String args[]) throws Exception {
    BufferedReader clavier = new BufferedReader(new InputStreamReader(System.in));
    PrintStream ecran = System.out;
    ServerSocket leStandardTelephonique;
    if (args.length >= 1) port = Integer.parseInt(args[0]); else port = PortParDefaut;
    leStandardTelephonique = new ServerSocket(port);
    ecran.println("Demarrage du serveur de calcul sur port " + port);
    TraitementDesAppels leTraitementDesAppels = new TraitementDesAppels(leStandardTelephonique);
    leTraitementDesAppels.start();
    do {
      ecran.println("Q)uitter");
    } while(Conversion.enCaractere(clavier.readLine()) != 'q');
    leTraitementDesAppels.termine();
    leStandardTelephonique.close();
  }
}
